//+------------------------------------------------------------------+
//|                                          KG_MACD_Consultante.mq4 |
//|                                             Copyright  2011, KG |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

// ,    
extern int  Fast_EMA_Period=12, Slow_EMA_Period=24; //    
extern int  MA_Shift=0; //??????????????????????????????????????????????????????????????????
extern int  Signal_SMA_Period=9;

// ,   
int         Fast_EMA_CountedBars=0, Slow_EMA_CountedBars=0, Signal_SMA_CountedBars=0; //  
double      sum, Fast_Sum_EMA, Slow_Sum_EMA, Array_Fast_Sum_EMA[100], Array_Slow_Sum_EMA[100], Sum_SMA, Final_MACD, Array_MACD[], MACD_Sum_SMA; //     
double      MacdBuffer[100];
double      SignalBuffer[100];
double      ExtMapBuffer[100];
int         stage; //    .
int         j, jj, limit; 
double      limit_1;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();   //     ( , )
   
   if((Bars<=Fast_EMA_Period) && (Bars<=Slow_EMA_Period) && (Bars<=Signal_SMA_Period))
   {
      Comment("    ");   
      return(0);  //,       ,   
   }
   Fast_EMA_CountedBars=Fast_EMA_Period;
   Slow_EMA_CountedBars=Slow_EMA_Period;
   Signal_SMA_CountedBars=Signal_SMA_Period;
   if ((Fast_EMA_CountedBars<0) || (Slow_EMA_CountedBars<0) ||(Signal_SMA_CountedBars<0)) return(-1);
   if ((Fast_EMA_CountedBars>0) && (Slow_EMA_CountedBars>0) && (Signal_SMA_CountedBars>0)) 
   {
      Fast_EMA_CountedBars--;
      Slow_EMA_CountedBars--;
      Signal_SMA_CountedBars--;
   }
   
   if(counted_bars>0) counted_bars--;
   limit=Signal_SMA_Period*3;
   int element_count_1=ArrayResize( MacdBuffer, limit);
   int element_count_2=ArrayResize( SignalBuffer, limit);
   int element_count_3=ArrayResize( Array_Fast_Sum_EMA, limit);
   int element_count_4=ArrayResize( Array_Slow_Sum_EMA, limit);
   int element_count_5=ArrayResize( Array_MACD, limit);
   j=0;
   jj=0;
   stage=1; //1-  -  EMA
   ema();
   stage=2; //2-  -  EMA
   ema();    
   Final_MACD=Fast_Sum_EMA-Slow_Sum_EMA;
   limit_1=0;
   for(j=0; j<limit; j++)
   {
      stage=3; //3-  -   Fast ENA  
      ema();
      stage=4; //4-  -   Slow ENA  
      ema();
      Array_MACD[j]=(Array_Fast_Sum_EMA[j] - Array_Slow_Sum_EMA[j]);
   }
  for(jj=0; jj<Signal_SMA_Period; jj++) 
  {
      limit_1=limit_1+Array_MACD[jj];
  }
  MACD_Sum_SMA=limit_1/Signal_SMA_Period;
   
//   for(j=0; j<limit; j++)
//      SignalBuffer[j]=iMAOnArray(Array_MACD,Bars,Signal_SMA_Period,0,MODE_SMA,j);   
   
   Comment(Fast_Sum_EMA, ", ",Slow_Sum_EMA, ", ", MACD_Sum_SMA*100, ", ", Array_MACD[0]*100);
//   int ret=MessageBox("  = "+ limit_1/9);

   return(0);
  }

//+------------------------------------------------------------------+
//|      EMA                          |
//+------------------------------------------------------------------+


void ema()
  {
   sum=0; //  
   int i;
   int MA_Period=0; //    
   int CountedBars=0; //   
   
   //       
   if (stage==1) 
   {
      MA_Period=Fast_EMA_Period;
      CountedBars=IndicatorCounted();
      Fast_Sum_EMA=0;       
   }
   if (stage==2)
   {
      MA_Period=Slow_EMA_Period;
      CountedBars=Slow_EMA_CountedBars;
      Slow_Sum_EMA=0; 
   }
   
      if (stage==3)
   {
      MA_Period=Fast_EMA_Period;
      CountedBars=Fast_EMA_CountedBars;
      Array_Fast_Sum_EMA[j]=0; 
   }
      if (stage==4)
   {
      MA_Period=Slow_EMA_Period;
      CountedBars=Slow_EMA_CountedBars;
      Array_Slow_Sum_EMA[j]=0; 
   }
   
   double pr=2.0/(MA_Period+1);
   int    pos=Bars-2-j;
   double Sum_MA=0;
   if(CountedBars>2) pos=Bars-CountedBars-1-j;
   int element_count=ArrayResize( ExtMapBuffer, pos);

  while(pos>=0)
     {
      if(pos==Bars-2) ExtMapBuffer[pos+1]=Close[pos+1];
      ExtMapBuffer[pos]=Close[pos]*pr+ExtMapBuffer[pos+1]*(1-pr);
      //int ret=MessageBox("  = "+ Close[pos+1]+", " +(ExtMapBuffer[pos+1]));
      Sum_MA=ExtMapBuffer[pos];
      if (stage==1) Fast_Sum_EMA=Sum_MA;
      if (stage==2) Slow_Sum_EMA=Sum_MA;
      if (stage==3) Array_Fast_Sum_EMA[j] =Sum_MA;
      if (stage==4) Array_Slow_Sum_EMA[j] =Sum_MA;
 	   pos--;
     }
  }

